-- =============================================
-- SaveToDB Sample 01 for Snowflake - Basic Features
-- Version 10.8, January 9, 2023
--
-- Copyright 2018-2023 Gartle LLC
--
-- License: MIT
-- =============================================

CREATE USER SAMPLE01_USER1 PASSWORD='Usr_2011#_Xls4168';
CREATE USER SAMPLE01_USER2 PASSWORD='Usr_2011#_Xls4168';

CREATE ROLE SAMPLE01_USERS;
CREATE ROLE SAMPLE01_ADV_USERS;

GRANT ROLE SAMPLE01_USERS   TO ROLE SAMPLE01_ADV_USERS;
GRANT USAGE ON SCHEMA S01   TO ROLE SAMPLE01_ADV_USERS;

GRANT USAGE ON WAREHOUSE COMPUTE_WH                                   TO ROLE SAMPLE01_USERS;
GRANT SELECT, INSERT, UPDATE, DELETE ON ALL TABLES      IN SCHEMA S01 TO ROLE SAMPLE01_USERS;
GRANT SELECT                         ON ALL VIEWS       IN SCHEMA S01 TO ROLE SAMPLE01_USERS;
GRANT USAGE                          ON ALL FUNCTIONS   IN SCHEMA S01 TO ROLE SAMPLE01_USERS;
GRANT USAGE                          ON ALL PROCEDURES  IN SCHEMA S01 TO ROLE SAMPLE01_USERS;

GRANT ROLE SAMPLE01_ADV_USERS   TO USER SAMPLE01_USER1;
GRANT ROLE SAMPLE01_USERS       TO USER SAMPLE01_USER2;

ALTER USER SAMPLE01_USER1 SET DEFAULT_ROLE=SAMPLE01_ADV_USERS;
ALTER USER SAMPLE01_USER2 SET DEFAULT_ROLE=SAMPLE01_USERS;

ALTER USER SAMPLE01_USER1 SET DEFAULT_WAREHOUSE='COMPUTE_WH';
ALTER USER SAMPLE01_USER2 SET DEFAULT_WAREHOUSE='COMPUTE_WH';
